Unit FWMath1;
{------------------------------------------------}
{-               -}
{-                   * FWMATH1 *                -}
{-      Copyright (C) .., 1990-2001    -}
{------------------------------------------------}
interface
uses  FWData;

type
  TfmMath1 = class(TObject)
  private
    { Private declarations }
  public
    { Public declarations }
     Procedure MinMax(var a1: array of double;
                      ma1: integer;
                      var bmin: double;
                      var bmax: double);
     Procedure MinMaxEmpty(var a1: array of double;
                           ma1: integer;
                           var bmin: double;
                           var bmax: double);
     Procedure MinMaxInt(var a1: array of integer;
                         ma1: integer;
                         var bmin: integer;
                         var bmax: integer);
     Procedure MinMaxIntEmpty(var a1: array of integer;
                              ma1: integer;
                              var bmin: integer;
                              var bmax: integer);
     Procedure Interpolation(var a1: array of double;
                             ma1: integer);
     Procedure Filtr31(var a1: array of double;
                      ma1: integer;
                      Hd1: ShortString);
     Procedure Filtr51(var a1: array of double;
                      ma1: integer;
                      Hd1: ShortString);
     Procedure Average1(var a1: array of double;
                        ma1: integer;
                        var mean: double;
                        var sigma: double);
     Procedure AverageEmpty(var a1: array of double;
                            ma1: integer;
                            var mean: double;
                            var sigma: double);
     Procedure AverageOut(var a1: array of double;
                          ma1: integer;
                          var mean: double;
                          var sigma: double);
     Procedure AverageEmptyOut(var a1: array of double;
                               ma1: integer;
                               var mean: double;
                               var sigma: double);
     Procedure StatOut;
     Procedure OutLiers(ma1: integer;
                        mean1: double;
                        sigma1: double;
                        var exmin: double;
                        var exmax: double);
     Procedure SigmaLevel;
     Procedure Variability;
     Procedure Distrib(var a1: array of double;
                       ma1: integer;
                       Hd1: ShortString;
                       mean1: double;
                       sigma1: double;
                       var ass: double;
                       var ex: double;
                       var pas: ShortString;
                       var pex: ShortString;
                       var err_txt: string;
                       Is05: boolean;
                       var IsNormal: boolean);
     Procedure DistrOut;
     Function Prob(mf: integer; tabs: double;Is05: boolean): ShortString;
     Procedure CorCf;
     Function FCrit(n1,n2: integer): double;
     Procedure Student;
     Procedure PairStudent;
     Procedure Norm;
     Procedure Logarifm;
     function RoundFloat(R: Extended; Decimals: Integer): Extended;
     function fRelSmall(X, Y: Extended): Boolean;
end;

var
  fmMath1: TfmMath1;

{-----------------------------------------------------}
implementation
uses FWStat0, FWTitle, FWArray, FWMath2,
     Windows, Dialogs, SysUtils, Math, System.UITypes;

Procedure TfmMath1.MinMaxEmpty(var a1: array of double;
                             ma1: integer;
                             var bmin: double;
                             var bmax: double);
var
   j: integer;
begin
   if ma1=0
       then
           begin
              bmax:=a1[0];
              bmin:=a1[0];
              Exit;
           end
   else if ma1<0
       then
           begin
              bmax:=vEmpty;
              bmin:=vEmpty;
              Exit;
           end;

   bmax:=-1e10;
   bmin:=1e10;
   for j:=0 to ma1 do
     begin
          if (a1[j]>bmax) and (a1[j]<>vEmpty)
                   then bmax:=a1[j];
          if (a1[j]<bmin) and (a1[j]<>vEmpty)
                   then bmin:=a1[j];
     end;
   if bmax=-1e10
     then bmax:=0;
   if bmin=1e10
     then bmin:=0;
end;

Procedure TfmMath1.MinMax(var a1: array of double;
                          ma1: integer;
                          var bmin: double;
                          var bmax: double);
var
   j: integer;
begin
   if ma1=0
       then
           begin
              bmax:=a1[0];
              bmin:=a1[0];
              Exit;
           end
   else if ma1<0
       then
           begin
              bmax:=vEmpty;
              bmin:=vEmpty;
              Exit;
           end;

   bmax:=a1[0];
   bmin:=a1[0];
   for j:=1 to ma1 do
     begin
          if bmax<a1[j] then bmax:=a1[j];
          if bmin>a1[j] then bmin:=a1[j];
     end;
end;

{------------------------------}
Procedure TfmMath1.MinMaxInt(var a1: array of integer;
                             ma1: integer;
                             var bmin: integer;
                             var bmax: integer);
var
   j: integer;
begin
   if ma1=0
       then
           begin
              bmax:=a1[0];
              bmin:=a1[0];
              Exit;
           end
   else if ma1<0
       then
           begin
              bmax:=vEmpty;
              bmin:=vEmpty;
              Exit;
           end;
   bmax:=a1[0];
   bmin:=a1[0];
   for j:=1 to ma1 do
     begin
        if bmax<a1[j] then bmax:=a1[j];
        if bmin>a1[j] then bmin:=a1[j];
     end;
end;

{------------------------------}
Procedure TfmMath1.MinMaxIntEmpty(var a1: array of integer;
                                  ma1: integer;
                                  var bmin: integer;
                                  var bmax: integer);
var
   j: integer;
begin
   if ma1=0
       then
           begin
              bmax:=a1[0];
              bmin:=a1[0];
              Exit;
           end
   else if ma1<0
       then
           begin
              bmax:=vEmpty;
              bmin:=vEmpty;
              Exit;
           end;

   bmax:=-1000000000;
   bmin:=1000000000;
   for j:=0 to ma1 do
     begin
        if (bmax<a1[j]) and (a1[j]<>vEmpty)
                 then bmax:=a1[j];
        if (bmin>a1[j]) and (a1[j]<>vEmpty)
                 then bmin:=a1[j];
     end;
end;

{--------------------------------------------------------}
Procedure TfmMath1.Interpolation(var a1: array of double;
                                 ma1: integer);
var
   dd,curj,j,k: integer;
   aa1,aa2,amean: double;
begin
   for j:=0 to ma1 do
     begin
        if a1[j]=vEmpty then
           begin
               dd:=0;
               if j=0 then   //    
                     begin
                        repeat
                              curj:=dd;
                              aa1:=a1[curj];
                              Inc(dd);
                          until (aa1<>vEmpty) or (curj=ma1);
                        if aa1<>vEmpty
                          then
                             begin
                                for k:=0 to (curj-1) do
                                a1[k]:=aa1;
                             end
                          else break;
                     end
                   else
                     begin
                        aa1:=a1[j-1];
                          repeat
                            curj:=j+dd;
                            aa2:=a1[curj];
                            Inc(dd);
                        until (aa2<>vEmpty) or (curj=ma1);
                        if aa2=vEmpty
                           then
                             begin
                                for k:=j to ma1 do
                                  a1[k]:=aa1
                             end
                          else
                             begin
                               amean:=(aa1+aa2)*0.5;
                               for k:=j to (curj-1) do
                                 a1[k]:=amean;
                             end;
                      end;
	         end;
     end;
end;

  {------------------------------------------------------------}
  {- : 31.05.00                                           -}
  {-                                                          -}
  {- : p    3  5        -}
  {-                                                          -}
  {- :  . p  p  pp  -}
  {-            .-.:,1987,.144-145 -}
  {------------------------------------------------------------}
Procedure TfmMath1.Filtr31(var a1: array of double;
                           ma1: integer;
                           Hd1: ShortString);
var
   fa1,fa2,fa3,famean,aB,aN: double;
   j: integer;
begin
   if ma1<7
           then
               begin
                    MessageDlg('   3 :   '+Trim(Hd1)+'  ',mtError,[mbOk],0);
                    Exit;
               end;
   aB:=(5*a1[1]+2*a1[2]-a1[3])/6;
   aN:=(5*a1[ma1]+2*a1[ma1-1]-a1[ma1-2])/6;

   fa1:=a1[1];
   fa2:=a1[2];
   fa3:=a1[3];
   for j:=1 to (ma1-1) do
       begin
    	  famean:=(fa1+fa2+fa3)/3;
	  fa1:=fa2;
	  fa2:=fa3;
	  if j<>(ma1-1) then fa3:=a1[j+2];
          a1[j]:=famean;
       end;

   if aB>=0 then
                a1[1]:=aB
            else
                a1[1]:=a1[2];
   if aN>=0 then
                a1[ma1]:=aN
            else
                a1[1]:=a1[ma1-1];
end;

Procedure TfmMath1.Filtr51(var a1: array of double;
                           ma1: integer;
                           Hd1: ShortString);
var
   f1,f2,f3,f4,f5,fmean,fa1,fa2,faN0,faN1: double;
   j: integer;
begin
   if ma1<11
           then
               begin
                  MessageDlg('   5 :   '+Trim(Hd1)+'  ',mtError,[mbOk],0);
                  Exit;
               end;
   fa1:=(3*a1[1]+2*a1[2]+a1[3]-a1[5])*0.2;
   fa2:=(4*a1[1]+3*a1[2]+2*a1[3]+a1[4])*0.1;
   faN0:=(a1[ma1-3]+2*a1[ma1-2]+3*a1[ma1-1]+4*a1[ma1])*0.1;
   faN1:=(3*a1[ma1]+2*a1[ma1-1]+a1[ma1-2]-a1[ma1-4])*0.2;

   f1:=a1[1];
   f2:=a1[2];
   f3:=a1[3];
   f4:=a1[4];
   f5:=a1[5];

   for j:=2 to (ma1-2) do
     begin
	fmean:=(f1+f2+f3+f4+f5)*0.2;
	f1:=f2;
	f2:=f3;
	f3:=f4;
	f4:=f5;
	if j<>(ma1-2)
           then f5:=a1[j+3];
	a1[j]:=fmean;
     end;

   if fa2>=0 then
                 a1[2]:=fa2
             else
                 a1[2]:=a1[3];
   if fa1>=0 then
	        a1[1]:=fa1
             else
                a1[1]:=fa2;

   if faN0>=0 then
                 a1[ma1-1]:=faN0
              else
                 a1[ma1-1]:=a1[ma1-2];
   if faN1>=0 then
                 a1[ma1]:=faN1
              else
                 a1[ma1]:=faN0;
end;
{--------------------------------------------------------------------}
Procedure TfmMath1.Average1(var a1: array of double;//VAR  ,  
                            ma1: integer;     //  -  
                            var mean: double;
                            var sigma: double);
var
   sum1,sum2,disp,df: double;
   j: integer;
begin
   if ma1<0
      then
          begin
               mean:=vEmpty;
               sigma:=vEmpty;
               Exit;
          end
   else if ma1=0
      then
          begin
               mean:=a1[0];
               sigma:=a1[0];
               Exit;
          end;
   sum1:=0.0;
   for j:=0 to ma1 do
     sum1:=sum1+a1[j];
   mean:=sum1/(ma1+1);

   sum2:=0.0;
   for j:=0 to ma1 do
     begin
        df:=RoundFloat((a1[j]-mean),4); // (2.2-2.2)<>0,  =-7.105e-15;
        sum2:=sum2+sqr(df);
     end;

   disp:=sum2/ma1; //n-1 .
   if disp>0
      then
          sigma:=sqrt(disp)
      else
          sigma:=0;
end;

{--------------------------------------------------------------------}
Procedure TfmMath1.AverageOut(var a1: array of double;
                                 ma1: integer;
                            var mean: double;
                           var sigma: double);
var
   exmin1,exmax1: double;
   j,mm1: integer;
   aa1: array of double;
begin
   if ma1<0
      then
          begin
               mean:=vEmpty;
               sigma:=vEmpty;
               Exit;
          end
   else if ma1=0
      then
          begin
               mean:=a1[0];
               sigma:=a1[0];
               Exit;
          end;

   Average1(a1,ma1,mean,sigma);
   OutLiers((ma1+1),mean,sigma,exmin1,exmax1);

   SetLength(aa1,(ma1+1));
   mm1:=0;
   for j:=0 to ma1 do
     if (a1[j]>=exmin1) and (a1[j]<=exmax1)
        then
            begin
               aa1[mm1]:=a1[j];
               Inc(mm1);
            end;
   Average1(aa1,(mm1-1),mean,sigma);
end;

{--------------------------------------------------------------------}
Procedure TfmMath1.AverageEmpty(var a1: array of double;
                                ma1: integer;
                                var mean: double;
                                var sigma: double);
var
   j,mm1: integer;
   aa1: array of double;
begin
   if ma1<0
      then
          begin
               mean:=vEmpty;
               sigma:=vEmpty;
               Exit;
          end
   else if ma1=0
      then
          begin
               mean:=a1[0];
               sigma:=a1[0];
               Exit;
          end;

   //   
   SetLength(aa1,(ma1+1));
   mm1:=0;
   for j:=0 to ma1 do
     if a1[j]<>vEmpty
        then
            begin
               aa1[mm1]:=a1[j];
               Inc(mm1);
            end;
   if mm1>0
           then
               Average1(aa1,(mm1-1),mean,sigma)
           else   //   
               begin
                  mean:=0;
                  sigma:=0;
               end;
end;

{--------------------------------------------------------------------}
Procedure TfmMath1.AverageEmptyOut(var a1: array of double;
                                   ma1: integer;
                                   var mean: double;
                                   var sigma: double);
var
   exmin1,exmax1: double;
   j,mm1,mm11,mm2: integer;
   aa1,aa2: array of double;
begin
   if ma1<0
      then
          begin
               mean:=vEmpty;
               sigma:=vEmpty;
               Exit;
          end
   else if ma1=0
      then
          begin
               mean:=a1[0];
               sigma:=a1[0];
               Exit;
          end;

   //   
   SetLength(aa1,(ma1+1));
   mm1:=0;
   for j:=0 to ma1 do
     if a1[j]<>vEmpty
        then
            begin
               aa1[mm1]:=a1[j];
               Inc(mm1);
            end;
   mm11:=mm1-1;
   Average1(aa1,mm11,mean,sigma);

   // 
   OutLiers(mm1,mean,sigma,exmin1,exmax1);
   SetLength(aa2,mm1);
   mm2:=0;
   for j:=0 to mm11 do
     if (aa1[j]>=exmin1) and (aa1[j]<=exmax1)
        then
            begin
               aa2[mm2]:=aa1[j];
               Inc(mm2);
            end;
   Average1(aa2,(mm2-1),mean,sigma);
end;


Procedure TfmMath1.StatOut;
  {---------------------------------------------------------}
  {-  : 29.06.92                                       -}
  {-                                                       -}
  {-  :        -}
  {-                                                       -}
  {-  : g  -                                 -}
  {-        n  -  p                               -}
  {-       mx  -    p                     -}
  {-       Hd  -                            -}
  {---------------------------------------------------------}
var
   mean1,sigma1,mm1: double;
   ma1: integer;
   i: byte;
   a1: array of double;
   Hd1: ShortString;
begin
   fmTitle.SubTitle1;
   fmMain.ProgressBar1.Max:=n1;
   SetLength(a1,mSize);
   for i:=0 to n1 do
     begin
        fmMain.ProgressBar1.Position:=i+1;
        fmArray.ExtractCol(i,a1,ma1,Hd1);
        Average1(a1,ma1,mean1,sigma1);
        mm1:=sigma1/sqrt(ma1);
	      writeln(g,' ',Hd[i]:8,'    ',(ma1+1):4,'  ',mean1:8:3,'  ',
                sigma1:9:3,'  ',mm1:8:3);
     end;
   writeln(g); writeln(g);
   a1:=nil;
end;

Procedure TfmMath1.OutLiers(ma1: integer;
                            mean1: double;
                            sigma1: double;
                            var exmin: double;
                            var exmax: double);
  {------------------------------------------------------------}
  {-   : 14.09.91                                         -}
  {-                                                          -}
  {-   :  min  max p "p", p    -}
  {-         p p   n@               -}
  {-                                                          -}
  {-   :  n -  p                                 -}
  {-         mx -    p                       -}
  {-       mean - p                             -}
  {-      sigma - pp              -}
  {-                                                          -}
  {-  : exmax - max p  "p"         -}
  {-         exmin - min -"-                                  -}
  {-                                                          -}
  {-  :  ..  p         -}
  {-         p p.-.:,1971,.16-18, -}
  {-         .172-173.                                       -}
  {------------------------------------------------------------}
type
    rum=array[1..27] of double;
var
   elx,pt: double;
   t: integer;
const                    {  p=0.05 }
     rm:rum= (3.04,2.78,2.62,2.51,2.43,2.37,2.33,2.29,2.26,2.24,
     2.22,2.20,2.18,2.17,2.145,2.105,2.079,2.061,2.048,
     2.038,2.030,2.018,2.009,2.003,1.998,1.994,1.960);
begin
   if ma1<0
      then
          begin
               exmin:=vEmpty;
               exmax:=vEmpty;
               Exit;
          end
   else if ma1=0
      then
          begin
               exmin:=mean1;
               exmax:=mean1;
               Exit;
          end;
   t:=ma1+1;
   if t<=5 then elx:=rm[1]
   else if t<=18 then elx:=rm[t-4]
   else if t<=20 then elx:=rm[15]
   else if t<=25 then elx:=rm[16]
   else if t<=30 then elx:=rm[17]
   else if t<=35 then elx:=rm[18]
   else if t<=40 then elx:=rm[19]
   else if t<=45 then elx:=rm[20]
   else if t<=50 then elx:=rm[21]
   else if t<=60 then elx:=rm[22]
   else if t<=70 then elx:=rm[23]
   else if t<=80 then elx:=rm[24]
   else if t<=90 then elx:=rm[25]
   else if t<=100 then elx:=rm[26]
   else elx:=rm[27]+100*(rm[26]-rm[27])/t;

   if t<30 then pt:=sqrt((t+1)/t) else pt:=1.0;
   exmax:=mean1+elx*sigma1*pt;
   exmax:=RoundFloat(exmax,4); //   :  AvarageOut (15.6>=15.6) -> false
   exmin:=mean1-elx*sigma1*pt;
   exmin:=RoundFloat(exmin,4);
end;

Procedure TfmMath1.Variability;
  {---------------------------------------------------------}
  {-    : 14.09.91                                     -}
  {-                                                       -}
  {-    :  min  max , p             -}
  {-          p p   n@      -}
  {-                                                       -}
  {-    :  g -   p                 -}
  {-           a - p                         -}
  {-           n -  p                             -}
  {-          mx -    p                   -}
  {-        mean - p                         -}
  {-       sigma - pp          -}
  {-          Hd -                          -}
  {-                                                       -}
  {-    : exmax - max "p"                        -}
  {-           exmin - min "p"                        -}
  {---------------------------------------------------------}
var
   i: byte;
   ma1: integer;
   mean1,sigma1,xmin,xmax: double;
   exmin,exmax: double;
   Hd1: ShortString;
   a1: array of double;

begin
   fmTitle.SubTitle2a;
   fmMain.ProgressBar1.Max:=n1;
   ma1:=m1;
   SetLength(a1,mSize);
   for i:=0 to n1 do
     begin
        fmMain.ProgressBar1.Position:=i;
        fmArray.ExtractCol(i,a1,ma1,Hd1);
        Average1(a1,ma1,mean1,sigma1);
        MinMax(a1,ma1,xmin,xmax);
        OutLiers(ma1,mean1,sigma1,exmin,exmax);
        writeln(g,' ',Hd[i]:8,'    ',xmin:8:3,'  ',xmax:8:3,'    ',
                exmin:8:3,'  ',exmax:8:3);
     end;
   writeln(g); writeln(g);
   a1:=nil;
end;

{--------------------------------------------------------------------}
Procedure TfmMath1.SigmaLevel;
var
   i: byte;
   ma1: integer;
   mean1,sigma1,s1,s15,s2,sMy: double;
   Hd1: ShortString;
   s: string;
   a1: array of double;
begin
   fmTitle.SubTitle2b;
   fmMain.ProgressBar1.Max:=2*n1;
   SetLength(a1,mSize);
   for i:=0 to n1 do
     begin
        fmMain.ProgressBar1.Position:=i;
        fmArray.ExtractCol(i,a1,ma1,Hd1);
        Average1(a1,ma1,mean1,sigma1);
        s1:=mean1+sigma1;
        s15:=mean1+1.5*sigma1;
        s2:=mean1+2.0*sigma1;
        if SetMyLevel then
                          begin
                               sMy:=mean1+SigmaN*sigma1;
                               Str(sMy:8:3,s);
                          end
                      else
                          s:='...?';
        writeln(g,' ',Hd[i]:8,'   ',mean1:8:3,'   ',sigma1:9:3,'   ',s1:8:3,'   ',s15:8:3,'   ',s2:8:3,'   ',s);
     end;
   writeln(g); writeln(g);

   fmTitle.SubTitle2c;
   for i:=0 to n1 do
     begin
        fmMain.ProgressBar1.Position:=i+n1;
        fmArray.ExtractCol(i,a1,ma1,Hd1);
        Average1(a1,ma1,mean1,sigma1);
        s1:=mean1-sigma1;
	      s15:=mean1-1.5*sigma1;
	      s2:=mean1-2.0*sigma1;
        if SetMyLevel then
                          begin
                               sMy:=mean1-SigmaN*sigma1;
                               Str(sMy:8:3,s);
                          end
                      else
                          s:='...?';
        writeln(g,' ',Hd[i]:8,'   ',mean1:8:3,'   ',sigma1:9:3,'   ',s1:8:3,'   ',s15:8:3,'   ',s2:8:3,'   ',s);
     end;
   writeln(g); writeln(g);
   a1:=nil;
end;

{--------------------------------------------------------------------}
Procedure TfmMath1.Distrib(var a1: array of double;
                           ma1: integer;
                           Hd1: ShortString;
                           mean1: double;
                           sigma1: double;
                           var ass: double;
                           var ex: double;
                           var pas: ShortString;
                           var pex: ShortString;
                           var err_txt: string;
                           Is05: boolean;
                           var IsNormal: boolean);
// .. .-.,1990,.136-7,340.
var
   as0,ex0,pp,tt: double;
   p3,t3: double;
   j: integer;
   bas,bex: boolean;

Function AsReliability(ma1:integer;
                       asX:double;
                       Is05: boolean;
                       var pas: ShortString): boolean;
type
   AsLevel= array [1..2,1..18] of double;
var
   na: integer;
   t: integer;
const
    pasm: AsLevel=((0.711,0.661,0.621,0.587,0.558,0.533,0.492,0.459,
        0.432,0.409,0.389,0.350,0.321,0.298,0.280,0.251, 0.23,0.213),
		   (1.061,0.928,0.921,0.869,0.825,0.787,0.723,0.673,
		    0.631,0.596,0.567,0.508,0.464,0.43,0.403, 0.36,0.329,0.305));
begin
   t:=ma1;
   if t<=25 then na:=1
   else if t<=30 then na:=2
   else if t<=35 then na:=3
   else if t<=40 then na:=4
   else if t<=45 then na:=5
   else if t<=50 then na:=6
   else if t<=60 then na:=7
   else if t<=70 then na:=8
   else if t<=80 then na:=9
   else if t<=90 then na:=10
   else if t<=100 then na:=11
   else if t<=125 then na:=12
   else if t<=150 then na:=13
   else if t<=175 then na:=14
   else if t<=200 then na:=15
   else if t<=250 then na:=16
   else if t<=300 then na:=17
   else na:=18;

   asX:=abs(asX);
   Result:=false;
   if asX>=pasm[2,na] then pas:='<0.01'
   else if asX>=pasm[1,na] then pas:='<0.05'
   else
       begin
          Result:=true;
          if Is05
               then
                   pas:=Plevel
               else
                   pas:='     ';
      end;
end;

{---------------------}
Function ExReliability(ma:integer;
                       Exs:double;
                       Is05: boolean;
                       var pex: ShortString): boolean;
type
    ExLevel= array [1..2,1..17] of double;
var
   ne: integer;
const
    pex0: ExLevel=((0.907,0.888,0.877,0.869,0.863,0.858,0.854,0.851,
      	           0.848,0.843,0.840,0.838,0.835,0.834,0.823,0.818,
		   0.816),
		  (0.936,0.914,0.900,0.890,0.883,0.877,0.872,0.868,
		   0.865,0.859,0.855,0.852,0.848,0.846,0.832,
		   0.826,0.822));
begin
   if ma<=11 then ne:=1
   else if ma<=16 then ne:=2
   else if ma<=21 then ne:=3
   else if ma<=26 then ne:=4
   else if ma<=31 then ne:=5
   else if ma<=36 then ne:=6
   else if ma<=41 then ne:=7
   else if ma<=46 then ne:=8
   else if ma<=51 then ne:=9
   else if ma<=61 then ne:=10
   else if ma<=81 then ne:=11
   else if ma<=91 then ne:=12
   else if ma<=101 then ne:=13
   else if ma<=201 then ne:=14
   else if ma<=301 then ne:=15
   else if ma<=401 then ne:=16
   else ne:=17;

   Exs:=abs(Exs);
   Result:=false;
   if Exs>=pex0[2,ne] then pex:='<0.01'
   else if Exs>=pex0[1,ne] then pex:='<0.05'
   else
       begin
          Result:=true;
          if Is05
               then
                   pex:=Plevel
               else
                   pex:='     ';
       end;
end;

{---------------------}
begin
   as0:=0.0;
   ex0:=0.0;
   for j:=0 to ma1 do
     begin
        tt:=a1[j]-mean1;
        t3:=IntPower(tt,3);
        ex0:=ex0+t3*tt;
        as0:=as0+t3;
     end;

   pp:=sigma1;
   if pp<>0
           then
               begin
                  p3:=IntPower(pp,3);
                  ex0:=ex0/((ma1+1)*pp*p3)-3;
                  as0:=as0/((ma1+1)*p3);
                  bas:=AsReliability((ma1+1),as0,Is05,pas);//  < 
                  bex:=ExReliability((ma1+1),ex0,Is05,pex);
                  if (bas and bex)
                    then
                        IsNormal:=true
                    else
                        IsNormal:=false;
                  ass:=as0;
                  ex:=ex0;
                   err_txt:='';
               end
          else
               begin
                  err_txt:='   @ = 0        ';
                  pas:='';
                  pex:='';
                  ass:=vEmpty;
                  ex:=vEmpty;
                  IsNormal:=true; //  
               end;
end;

Procedure TfmMath1.DistrOut;
  {---------------------------------------------------}
  {-   : 18.07.92                                -}
  {-                                                 -}
  {-   :   pp,    -}
  {-         p,         -}
  {-                                                 -}
  {-   :  a - p                    -}
  {-          n -  p                        -}
  {-         mx -    p              -}
  {-       mean - p                    -}
  {-      sigma - pp     -}
  {-                                                 -}
  {-   : as  - p                       -}
  {-          pas -  p            -}
  {-          ex  -                           -}
  {-          pex -                -}
  {---------------------------------------------------}
var
   i: byte;
   ma1: integer;
   mean1,sigma1,ass,ex,x2: double;
   Hd1,pas,pex,px2: ShortString;
   ass_s,ex_s,x2_s: string;
   err_txt, err_txt1: string;
   a1: array of double;
   IsNormal: boolean;
begin
   fmTitle.SubTitle8;
   fmMain.ProgressBar1.Max:=n1;
   SetLength(a1,mSize);
   for i:=0 to n1 do
     begin
        fmMain.ProgressBar1.Position:=i;
        fmArray.ExtractCol(i,a1,ma1,Hd1);
        Average1(a1,ma1,mean1,sigma1);
        Distrib(a1,ma1,Hd1,mean1,sigma1,ass,ex,pas,pex,err_txt,false,IsNormal);
        fmMath2.Pirson(a1,ma1,Hd1,mean1,sigma1,x2,px2,err_txt1,false,IsNormal);
        if ass<>vEmpty
              then
                  begin
                     Str(ass:8:2,ass_s);
                     ass_s:=ass_s+'  '+pas;
                  end
              else
                  ass_s:=err_txt;
        if ex<>vEmpty
              then
                  begin
                      Str(ex:8:2,ex_s);
                      ex_s:=ex_s+'  '+pex;
                  end
              else
                  ex_s:=err_txt;
        if x2<>vEmpty
              then
                  begin
                      Str(x2:8:2,x2_s);
                      x2_s:=x2_s+'  '+px2;
                  end
              else
                  x2_s:=err_txt1;
        writeln(g,' ',Hd1:8,'    ',ass_s,'  ',ex_s,'    ',x2_s);
     end;
   writeln(g); writeln(g);
   a1:=nil;
end;

Function TfmMath1.Prob(mf: integer; tabs: double; Is05: boolean): ShortString;
  {-----------------------------------------------------------------}
  {-      : 01.91                                              -}
  {-                                                               -}
  {-      :  p : 0.05, 0.01, 0.001,   -}
  {-            .. p   p p -   -}
  {-            p 0 ,   p.             -}
  {-            p  p p: p          -}
  {-              !                     -}
  {-                                                               -}
  {-      :   mf  -                        -}
  {-            tabs  -  t                                 -}
  {-     : prob  - p                          -}
  {-----------------------------------------------------------------}
type
    stud=array [1..3,1..37] of double;
var
    nm: integer;
const                                         {p=0.05}
    stt:stud=((12.7,4.3,3.18,2.78,2.57,2.45,2.37,2.31,2.26,2.23,
               2.2,2.18,2.16,2.15,2.13,2.12,2.11,2.1,2.09,2.09,2.08,
               2.07,2.07,2.06,2.06,2.06,2.05,2.05,2.04,2.04,2.02,
               2.01,2.0,1.99,1.98,1.98,1.96), {p=0.01}
              (63.7,9.93,5.84,4.6,4.03,3.71,3.5,3.36,3.25,3.17,3.11,
               3.06,3.01,2.98,2.95,2.92,2.9,2.88,2.86,2.85,2.83,2.82,
               2.81,2.8,2.79,2.78,2.77,2.76,2.76,2.75,2.7,2.68,2.66,
               2.64,2.63,2.62,2.58),          {p=0.001}
              (64.6,31.6,12.94,8.61,6.68,5.96,5.41,5.04,4.78,4.59,
               4.44,4.32,4.22,4.14,4.04,4.02,3.97,3.92,3.88,3.85,
               3.82,3.79,3.77,3.75,3.73,3.71,3.69,3.67,3.66,3.65,
               3.55,3.5,3.46,3.42,3.39,3.37,3.29));
begin
   if mf<=1 then nm:=1
   else if mf<=31 then nm:=mf-1
   else if mf<=41 then nm:=31
   else if mf<=51 then nm:=32
   else if mf<=61 then nm:=33
   else if mf<=81 then nm:=34
   else if mf<=101 then nm:=35
   else if mf<=121 then nm:=36
   else nm:=37;

   if tabs>=stt[3,nm] then Result:='<0.001'
   else if tabs>=stt[2,nm] then Result:='<0.01 '
   else if tabs>=stt[1,nm] then Result:='<0.05 '
   else
        if Is05
               then
                   Result:=Plevel
               else
                   Result:='     ';
end;

Procedure TfmMath1.CorCf;
  {--------------------------------------------------------------}
  {-   : 05.03.96                                           -}
  {-                                                            -}
  {-   :     pp         -}
  {-                                                            -}
  {-   : g  -   p                       -}
  {-         a  - p                               -}
  {-         n  -  p                                   -}
  {-         mx -    p                         -}
  {-         Hd  -                               -}
  {-                                                            -}
  {-  : p pp   "p-2".-.,1973,       -}
  {-         .24-29.                                           -}
  {-          .. p.-.:..-1990, .228-237  -}
  {--------------------------------------------------------------}
var
   df,cor,mean1,mean2,pc,sigma1,sigma2,sum3,tk,tabs1: double;
   k,i: byte;
   j,ma1,ma2,nm: integer;
   a1,a2: array of double;
   Hd1,Hd2,pcor: ShortString;

begin
   fmTitle.SubTitle3;
   fmMain.ProgressBar1.Max:=(sqr(n1)-n1) div 2;
   nm:=0;
   SetLength(a1,mSize);
   SetLength(a2,mSize);

   for i:=0 to n1 do
     for k:=(i+1) to n1 do
       begin
          Inc(nm);
          fmMain.ProgressBar1.Position:=nm;
          fmArray.ExtractCol(i,a1,ma1,Hd1);
          fmArray.ExtractCol(k,a2,ma2,Hd2);
          if ma1<>ma2
              then
                  begin
                     writeln(g,' ',Hd1,' ',Hd2,'    :  ');
  	             continue;
           	  end;
          if IsPairEmptyDel
               then fmArray.DelPairEmpty(a1,a2,ma1);
          if IsPairOutDel
               then fmArray.DelPairOut(a1,a2,ma1);
          Average1(a1,ma1,mean1,sigma1);
          Average1(a2,ma2,mean2,sigma2);
          if (sigma1=0.0) or (sigma2=0.0)
           then
              begin
                 writeln(g,' ',Hd1:8,' ',Hd2:8,'    : @=0');
                 continue;
	            end
           else
              begin
                 sum3:=0.0;
                 for j:=0 to ma1 do
                       sum3:=sum3+(a1[j]-mean1)*(a2[j]-mean2);
                  pc:=sum3/ma1;

   	              cor:=pc/(sigma1*sigma2);
                  if cor<>1
                     then
                        begin
                           df:=abs(1.0-sqr(cor)); //  
                           if ma1<100
                             then
                              tk:=cor*sqrt(ma1-1)/sqrt(df)
                             else
                                tk:=cor*sqrt(ma1+1)/sqrt(df);
                           tabs1:=abs(tk);
                           pcor:=prob((ma1-1),tabs1,true);
                        end
                     else
  	                pcor:='<0.001';
              end;
           if (IsReliable and (pcor='      ')) then continue;
           writeln (g,' ',Hd1:8,' ',Hd2:8,'   ',(ma1+1):4,'    ',cor:6:3,'      ',pcor);
       end;
   writeln(g); writeln(g);
   a1:=nil;
   a2:=nil;
end;

{---------- F-  (5%)----------}
Function TfmMath1.FCrit(n1,n2: integer): double;
type
    FArray = array[1..52,1..24] of double;
const
    F: FArray=((161,200,216,225,230,234,237,239,241,242,243,244,245,246,
                248,249,250,251,252,253,253,254,254,254),
               (18.51,19.00,19.16,19.25,19.30,19.33,19.36,19.37,19.38,19.39,
                19.40,19.41,19.42,19.43,19.44,19.45,19.46,19.47,19.47,19.48,
                19.49,19.49,19.50,19.50),
               (10.13,9.55,9.28,9.12,9.07,8.94,8.88,8.84,8.81,8.78,8.76,8.74,
                 8.71,8.69,8.66,8.64,8.62,8.60,8.58,8.57,8.56,8.54,8.54,8.53),
                (7.71,6.94,6.59,6.39,6.26,6.16,6.09,6.04,6.00,5.96,5.92,5.91,
                 5.87,5.84,5.80,5.77,5.74,5.71,5.70,5.68,5.66,5.65,5.64,5.63),
                (6.61,5.79,5.41,5.19,5.05,4.95,4.88,4.82,4.78,4.74,4.70,4.68,
                 4.64,4.60,4.56,4.53,4.50,4.46,4.44,4.42,4.40,4.38,4.37,4.36),
                (5.99,5.14,4.76,4.53,4.39,4.28,4.21,4.15,4.10,4.06,4.03,4.00,
                 3.96,3.92,3.87,3.84,3.81,3.77,3.75,3.72,3.71,3.69,3.68,3.67),
                (5.59,4.74,4.35,4.12,3.97,3.87,3.79,3.73,3.68,3.63,3.60,3.57,
                 3.52,3.49,3.44,3.41,3.38,3.34,3.32,3.29,3.28,3.25,3.24,3.23),
                (5.32,4.46,4.07,3.84,3.69,3.58,3.50,3.44,3.39,3.34,3.31,3.28,
                 3.23,3.20,3.15,3.12,3.08,3.05,3.03,3.00,2.98,2.96,2.94,2.93),
                (5.12,4.26,3.86,3.63,3.48,3.37,3.29,3.23,3.18,3.13,3.10,3.07,
                 3.02,2.98,2.93,2.90,2.86,2.82,2.80,2.77,2.76,2.73,2.72,2.71),
                (4.96,4.10,3.71,3.48,3.33,3.22,3.14,3.07,3.02,2.97,2.94,2.91,
                 2.86,2.81,2.77,2.74,2.70,2.67,2.64,2.61,2.59,2.56,2.55,2.54),
                (4.84,3.98,3.59,3.36,3.20,3.09,3.01,2.95,2.90,2.86,2.82,2.79,
                 2.74,2.70,2.65,2.61,2.57,2.53,2.50,2.47,2.45,2.42,2.41,2.40),
                (4.75,3.88,3.49,3.26,3.11,3.00,2.92,2.85,2.80,2.76,2.72,2.69,
                 2.64,2.60,2.54,2.50,2.46,2.42,2.40,2.36,2.35,2.32,2.31,2.30),
                (4.67,3.80,3.41,3.18,3.02,2.92,2.84,2.77,2.72,2.67,2.63,2.60,
                 2.55,2.51,2.46,2.42,2.38,2.34,2.32,2.28,2.26,2.24,2.22,2.21),
                (4.60,3.74,3.34,3.11,2.96,2.85,2.77,2.70,2.65,2.60,2.56,2.53,
                 2.48,2.44,2.39,2.35,2.31,2.27,2.24,2.21,2.19,2.16,2.14,2.13),
                (4.54,3.68,3.29,3.06,2.90,2.79,2.70,2.64,2.59,2.55,2.51,2.48,
                 2.43,2.39,2.33,2.29,2.25,2.21,2.18,2.15,2.12,2.10,2.08,2.07),
                (4.49,3.63,3.24,3.01,2.85,2.74,2.66,2.59,2.54,2.49,2.45,2.42,
                 2.37,2.33,2.28,2.24,2.20,2.16,2.13,2.09,2.07,2.04,2.02,2.01),
                (4.45,3.59,3.20,2.96,2.81,2.70,2.62,2.55,2.50,2.45,2.41,2.38,
                 2.33,2.29,2.23,2.19,2.15,2.11,2.08,2.04,2.02,1.99,1.97,1.96),
                (4.41,3.55,3.16,2.93,2.77,2.66,2.58,2.51,2.46,2.41,2.37,2.34,
                 2.29,2.25,2.19,2.15,2.11,2.07,2.04,2.00,1.98,1.95,1.93,1.92),
                (4.38,3.52,3.13,2.90,2.74,2.63,2.55,2.48,2.43,2.38,2.34,2.31,
                 2.26,2.21,2.15,2.11,2.07,2.02,2.00,1.96,1.94,1.91,1.90,1.88),
                (4.35,3.49,3.10,2.87,2.71,2.60,2.52,2.45,2.40,2.35,2.31,2.28,
                 2.23,2.18,2.12,2.08,2.04,1.99,1.96,1.92,1.90,1.87,1.85,1.84),
                (4.32,3.47,3.07,2.84,2.68,2.57,2.49,2.42,2.37,2.32,2.28,2.25,
                 2.20,2.15,2.09,2.05,2.00,1.96,1.93,1.89,1.87,1.84,1.82,1.81),
                (4.30,3.44,3.05,2.82,2.66,2.55,2.47,2.40,2.35,2.30,2.26,2.23,
                 2.18,2.13,2.07,2.03,1.98,1.93,1.91,1.87,1.84,1.81,1.80,1.78),
                (4.28,3.42,3.03,2.80,2.64,2.53,2.45,2.38,2.32,2.28,2.24,2.20,
                 2.14,2.10,2.04,2.00,1.96,1.91,1.88,1.84,1.82,1.79,1.77,1.76),
                (4.26,3.40,3.01,2.78,2.62,2.51,2.43,2.36,2.30,2.26,2.22,2.18,
                 2.13,2.09,2.02,1.98,1.94,1.89,1.86,1.82,1.80,1.76,1.74,1.73),
                (4.24,3.38,2.99,2.76,2.60,2.49,2.41,2.34,2.28,2.24,2.20,2.16,
                 2.11,2.06,2.00,1.96,1.92,1.87,1.84,1.80,1.77,1.74,1.72,1.71),
                (4.22,3.37,2.98,2.74,2.59,2.47,2.39,2.32,2.27,2.22,2.18,2.15,
                 2.10,2.05,1.99,1.95,1.90,1.85,1.82,1.78,1.76,1.72,1.70,1.69),
                (4.21,3.35,2.96,2.73,2.57,2.46,2.37,2.30,2.25,2.20,2.16,2.13,
                 2.08,2.03,1.97,1.93,1.88,1.84,1.80,1.76,1.74,1.71,1.68,1.67),
                (4.20,3.34,2.95,2.71,2.56,2.44,2.36,2.29,2.24,2.19,2.15,2.12,
                 2.06,2.02,1.96,1.91,1.87,1.81,1.78,1.75,1.72,1.69,1.67,1.65),
                (4.18,3.33,2.93,2.70,2.54,2.43,2.35,2.28,2.22,2.18,2.14,2.10,
                 2.05,2.00,1.94,1.90,1.85,1.80,1.77,1.73,1.71,1.68,1.65,1.64),
                (4.17,3.32,2.92,2.69,2.53,2.42,2.34,2.27,2.21,2.16,2.12,2.09,
                 2.04,1.99,1.93,1.89,1.84,1.79,1.76,1.72,1.69,1.66,1.64,1.62),
                (4.15,3.30,2.90,2.67,2.51,2.40,2.32,2.25,2.19,2.14,2.10,2.07,
                 2.02,1.97,1.91,1.86,1.82,1.76,1.74,1.69,1.67,1.64,1.61,1.59),
                (4.13,3.28,2.88,2.65,2.49,2.38,2.30,2.23,2.17,2.12,2.08,2.05,
                 2.00,1.95,1.89,1.84,1.80,1.74,1.71,1.67,1.64,1.61,1.59,1.57),
                (4.11,3.26,2.86,2.63,2.48,2.36,2.28,2.21,2.15,2.10,2.06,2.03,
                 1.98,1.93,1.87,1.82,1.78,1.72,1.69,1.65,1.62,1.59,1.56,1.55),
                (4.10,3.25,2.85,2.62,2.46,2.35,2.26,2.19,2.14,2.09,2.05,2.02,
                 1.96,1.92,1.85,1.80,1.76,1.71,1.67,1.63,1.60,1.57,1.54,1.53),
                (4.08,3.23,2.84,2.61,2.45,2.34,2.25,2.18,2.12,2.07,2.04,2.00,
                 1.95,1.90,1.84,1.79,1.74,1.69,1.66,1.61,1.59,1.55,1.53,1.51),
                (4.07,3.22,2.83,2.59,2.44,2.32,2.24,2.17,2.11,2.06,2.02,1.99,
                 1.94,1.89,1.82,1.78,1.73,1.68,1.64,1.60,1.57,1.54,1.51,1.49),
                (4.06,3.21,2.82,2.58,2.43,2.31,2.23,2.16,2.10,2.05,2.01,1.98,
                 1.92,1.88,1.81,1.76,1.72,1.66,1.63,1.58,1.56,1.52,1.50,1.48),
                (4.05,3.20,2.81,2.57,2.42,2.30,2.22,2.14,2.09,2.04,2.00,1.97,
                 1.91,1.87,1.80,1.75,1.71,1.65,1.62,1.57,1.54,1.51,1.48,1.46),
                (4.04,3.19,2.80,2.56,2.41,2.30,2.21,2.14,2.08,2.03,1.99,1.96,
                 1.90,1.86,1.79,1.74,1.70,1.64,1.61,1.56,1.53,1.50,1.47,1.45),
                (4.03,3.18,2.79,2.56,2.40,2.29,2.20,2.13,2.07,2.02,1.98,1.95,
                 1.90,1.85,1.78,1.74,1.69,1.63,1.60,1.55,1.52,1.48,1.46,1.44),
                (4.02,3.17,2.78,2.54,2.38,2.27,2.18,2.11,2.05,2.00,1.97,1.93,
                 1.88,1.83,1.76,1.72,1.67,1.61,1.58,1.52,1.50,1.46,1.43,1.41),
                (4.00,3.15,2.76,2.52,2.37,2.25,2.17,2.10,2.04,1.99,1.95,1.92,
                 1.86,1.81,1.75,1.70,1.65,1.59,1.56,1.50,1.48,1.44,1.41,1.39),
                (3.99,3.14,2.75,2.51,2.36,2.24,2.15,2.08,2.02,1.98,1.94,1.90,
                 1.85,1.80,1.73,1.68,1.63,1.57,1.54,1.49,1.46,1.42,1.39,1.37),
                (3.98,3.13,2.74,2.50,2.35,2.23,2.14,2.07,2.01,1.97,1.93,1.89,
                 1.84,1.79,1.72,1.67,1.62,1.56,1.53,1.47,1.45,1.40,1.37,1.35),
                (3.96,3.11,2.72,2.48,2.33,2.21,2.12,2.05,1.99,1.95,1.91,1.88,
                 1.82,1.77,1.70,1.65,1.60,1.54,1.51,1.45,1.42,1.38,1.35,1.32),
                (3.94,3.09,2.70,2.46,2.30,2.19,2.10,2.03,1.97,1.92,1.88,1.85,
                 1.79,1.75,1.68,1.63,1.57,1.51,1.48,1.42,1.39,1.34,1.30,1.28),
                (3.92,3.07,2.68,2.44,2.29,2.17,2.08,2.01,1.95,1.90,1.86,1.83,
                 1.77,1.72,1.65,1.60,1.55,1.49,1.45,1.39,1.36,1.31,1.27,1.25),
                (3.91,3.06,2.67,2.43,2.27,2.16,2.07,2.00,1.94,1.89,1.85,1.82,
                 1.76,1.71,1.64,1.59,1.54,1.47,1.44,1.37,1.34,1.29,1.25,1.22),
                (3.89,3.04,2.65,2.41,2.26,2.14,2.05,1.98,1.92,1.87,1.83,1.80,
                 1.74,1.69,1.62,1.57,1.52,1.45,1.42,1.35,1.32,1.26,1.22,1.19),
                (3.86,3.02,2.62,2.39,2.23,2.12,2.03,1.96,1.90,1.85,1.81,1.78,
                 1.72,1.67,1.60,1.54,1.49,1.42,1.38,1.32,1.28,1.22,1.16,1.13),
                (3.85,3.00,2.61,2.38,2.22,2.10,2.02,1.95,1.89,1.84,1.80,1.76,
                 1.70,1.65,1.58,1.53,1.47,1.41,1.36,1.30,1.26,1.19,1.13,1.08),
                (3.84,2.99,2.60,2.37,2.21,2.09,2.01,1.94,1.88,1.83,1.79,1.75,
                 1.69,1.64,1.57,1.52,1.46,1.40,1.35,1.28,1.24,1.17,1.11,1.00));
var
   ns1,ns2: integer;
begin
   if (n1<=12) then ns1:=n1
   else if n1<=14 then ns1:=13
   else if n1<=16 then ns1:=14
   else if n1<=20 then ns1:=15
   else if n1<=24 then ns1:=16
   else if n1<=30 then ns1:=17
   else if n1<=40 then ns1:=18
   else if n1<=50 then ns1:=19
   else if n1<=75 then ns1:=20
   else if n1<=100 then ns1:=21
   else if n1<=200 then ns1:=22
   else if n1<=500 then ns1:=23
   else ns1:=24;

   if n2<=30 then ns2:=n2
   else if n2<=32 then ns2:=31
   else if n2<=34 then ns2:=32
   else if n2<=36 then ns2:=33
   else if n2<=38 then ns2:=34
   else if n2<=40 then ns2:=35
   else if n2<=42 then ns2:=36
   else if n2<=44 then ns2:=37
   else if n2<=46 then ns2:=38
   else if n2<=48 then ns2:=39
   else if n2<=50 then ns2:=40
   else if n2<=55 then ns2:=41
   else if n2<=60 then ns2:=42
   else if n2<=65 then ns2:=43
   else if n2<=70 then ns2:=44
   else if n2<=80 then ns2:=45
   else if n2<=100 then ns2:=46
   else if n2<=125 then ns2:=47
   else if n2<=150 then ns2:=48
   else if n2<=200 then ns2:=49
   else if n2<=400 then ns2:=50
   else if n2<=1000 then ns2:=51
   else ns2:=52;

   Result:=F[ns2,ns1];
end;

Procedure TfmMath1.Student;
  {-----------------------------------------------------------}
  {-  : 18.08.95                                         -}
  {-                                                         -}
  {-  :    t-pp          -}
  {-                                                         -}
  {-  : g  -   p                     -}
  {-        a  - p                             -}
  {-        n  -  p                                 -}
  {-        mx -    p                       -}
  {-      mean - p                             -}
  {-     sigma - pp              -}
  {-        Hd -                              -}
  {-                                                         -}
  {- :  .  : p.  .-  -}
  {-        .: , 1976, . 241-252,142.            -}
  {-        TTEST(SSP)                                       -}
  {-----------------------------------------------------------}
var
   i,k: byte;
   j,mb1,mb2,ma1,ma2,ms1,ms2,mt,m_1,m_2,nm : integer;
   F,h,mt1,mt2,mt3,rr,s,s1,s2,ts : double;
   mean1,mean2,sigma1,sigma2: double;
   d,Ft,disp1,disp2: double;
   lgF: extended;
   Hd1,Hd2,pst: ShortString;
   a1,a2: array of double;

begin
   fmTitle.SubTitle5;
   fmMain.ProgressBar1.Max:=(sqr(n1)-n1) div 2;
   nm:=0;
   SetLength(a1,mSize);
   SetLength(a2,mSize);
   for i:=0 to n1 do
     for k:=(i+1) to n1 do
        begin
          Inc(nm);
          fmMain.ProgressBar1.Position:=nm;
          if (ShowEqualTitle and (Hd[i]<>Hd[k]))
              then continue;
          fmArray.ExtractCol(i,a1,ma1,Hd1);
          fmArray.ExtractCol(k,a2,ma2,Hd2);
          Average1(a1,ma1,mean1,sigma1);
          Average1(a2,ma2,mean2,sigma2);

          if sigma1>sigma2
                 then
                    begin
                       s1:=sigma1;
                       s2:=sigma2;
                       disp1:=sqr(s1);
                       disp2:=sqr(s2);
                       mb1:=ma1;
                       mb2:=ma2;
                    end
                 else
                    begin
                       s1:=sigma2;
                       s2:=sigma1;
                       disp1:=sqr(s1);
                       disp2:=sqr(s2);
                       mb1:=ma2;
                       mb2:=ma1;
                    end;
          if s2=0 then
                    begin
                        writeln(g,' ',Hd1:8,' ',Hd2:8,'      : @=0');
                        continue;
                    end;
          F:=s1/s2;
          ms1:=mb1;
          ms2:=mb2;
          if (ms1>30) and (ms2>30)  //   F
                  then
                     begin
                        d:=1/ms1-1/ms2;
                        h:=2*(1/ms1+1/ms2);
                        lgF:=1.4287/sqrt(abs(h-0.95))-0.681*d;
                        Ft:=Power(10,lgF);
                     end
                  else Ft:=FCrit(ms1,ms2);

          m_1:=mb1+1;
          m_2:=mb2+1;
          if F<Ft then
                     begin
                        mt:=m_1+m_2-2;
                        s:=sqrt((ms1*disp1+ms2*disp2)/mt);
                        ts:=(abs(mean1-mean2)/s)*(1/sqrt(1/m_1+1/m_2));
                     end
                  else
                     begin
                        rr:=sqrt(disp1/m_1+disp2/m_2);
                        ts:=abs(mean1-mean2)/rr;
                        mt1:=sqr(disp1/m_1+disp2/m_2);
                        mt2:=sqr(disp1/m_1)/(m_1+1);
                        mt3:=sqr(disp2/m_2)/(m_2+1);
                        mt:= round(mt1/(mt2+mt3)-2);
                     end;
       	  pst:=prob(mt,ts,true);
          if (IsReliable and (pst='      ')) then continue;
          writeln (g,' ',Hd1:8,' ',Hd2:8,'   ',m_1:4,'  ',m_2:4,'  ',
                     ts:8:3,'     ',pst);
       end;
   writeln(g); writeln(g);
   a1:=nil;
   a2:=nil;
end;

Procedure TfmMath1.PairStudent;
{-----------------------------------------------------------}
{                            }
{                                                           }
{ 1. .  .-.,1976,.286-287.   }
{ 2. .. .-.,1990,.118-120.                }
{-----------------------------------------------------------}
var
   i,k: byte;
   j,ma1,ma2,m0,nm: integer;
   pst: ShortString;
   d,s1,s2,s3,ts: double;
   Hd1,Hd2: ShortString;
   a1,a2: array of double;
begin
   fmTitle.SubTitle9;
   fmMain.ProgressBar1.Max:=(sqr(n1)-n1) div 2;
   nm:=0;
   SetLength(a1,mSize);
   SetLength(a2,mSize);
   for i:=0 to n1 do
     for k:=(i+1) to n1 do
        begin
          Inc(nm);
          fmMain.ProgressBar1.Position:=nm;
          if (ShowEqualTitle and (Hd[i]<>Hd[k]))
                then continue;
          if (mx[i]<>mx[k])
                then
                    begin
                       writeln(g,' ',Hd[i]:8,' ',Hd[k]:8,'     :  ');
                       continue;
                    end;
          fmArray.ExtractCol(i,a1,ma1,Hd1);
          fmArray.ExtractCol(k,a2,ma2,Hd2);
          if IsPairEmptyDel
                    then fmArray.DelPairEmpty(a1,a2,ma1);
          if IsPairOutDel
                    then fmArray.DelPairOut(a1,a2,ma1);
          s1:=0;
          s2:=0;
          for j:=0 to ma1 do
            begin
               d:=a1[j]-a2[j];
               s1:=s1+sqr(d);
               s2:=s2+d;
            end;
          m0:=ma1+1;
          if s1<>0 then
                       begin
                          s3:=m0*s1-sqr(s2);
                          ts:=abs(s2)/(sqrt(s3/(m0-1)));
       	                  pst:=prob(m0,ts,true);
                       end
                   else         { }
                       begin
                          if (IsReliable=false)
                            then
                              writeln (g,' ',Hd1:8,' ',Hd2:8,'     :  ');
                          continue;
                       end;
          if (IsReliable and (pst='      ')) then continue;
          writeln (g,' ',Hd1:8,' ',Hd2:8,'   ',m0:4,'  ', ts:8:3,'     ',pst);
       end;
   writeln(g); writeln(g);
   a1:=nil;
   a2:=nil;
end;

{-----------------------------------------------}
Procedure TfmMath1.Norm;
var
   i: byte;
   j,ma1: integer;
   mean1,sigma1: double;
   a1: array of double;
   Hd1: ShortString;
begin
 try
   Txt:=Txt+' .';
   SetLength(a1,mSize);
   for i:=0 to n1 do
     begin
        fmArray.ExtractCol(i,a1,ma1,Hd1);
        Average1(a1,ma1,mean1,sigma1);
        if sigma1=0
          then
             begin
                //Str(i,st);
                //MessageDlg(' : '+Trim(Hd1)+'  @=0',mtError,[mbOk],0);
                //writeln(g,Hd1,'   :   @=0');
                for j:=0 to ma1 do
                  a[i,j]:=0;
             end
          else
             begin
                for j:=0 to ma1 do
                  a[i,j]:=(a1[j]-mean1)/sigma1;
             end;
     end;
   a1:=nil;
 except
   on EZeroDivide do
       MessageDlg('   0',mtWarning,[mbOk],0);
   on EInvalidOp do
       MessageDlg('    ',mtWarning,[mbOk],0);
 end;
end;

Procedure TfmMath1.Logarifm;
{-----------------------------------------------------------}
{                                           }
{   -       }
{  ( ..)        }
{ >33% ( .) (??)        }
{  .                                           }
{                                                           }
{ 1. .  .-.,1976,.104-107.   }
{ 2. .., ..  -        }
{                }
{   . .,1979,178-182                               }
{-----------------------------------------------------------}
var i,j,ma1: integer;
begin
     Txt:=Txt+'.';
     for i:=0 to n1 do
       begin
          ma1:=mx[i]-1;
          for j:=0 to ma1 do
            begin
               if a[i,j]>0
                  then
                      a[i,j]:=ln(a[i,j])//   
               else if a[i,j]<0
                  then
                      a[i,j]:=ln(abs(a[i,j]));
            end;
       end;
end;

function TfmMath1.RoundFloat(R: Extended; Decimals: Integer): Extended;
{
      .
     .  
 c       ,
 a        
 .        
.          ,
..       ,
   (  ) .
}
var
   Factor: Extended;
begin
   Factor := Int(Exp(Decimals * Ln(10)));
   Result := Round(Factor * R) / Factor;
end;

function TfmMath1.fRelSmall(X, Y: Extended): Boolean;
{   MATH, ..   }
{  ,    X  Y  }
const
    C1: Double = 1E-15;
    C2: Double = 1E-12;
begin
     Result := Abs(X) < (C1 + C2 * Abs(Y))
end;

end.
